#include <iostream>
#include <vector>

#include <arc/certificate.h>

using namespace std;

int main()
{
	try {
		Certificate mycert; // my user certificate

		cout << "My user certificate:" << endl;
		cout << "Subject   : " << mycert.GetSN() << endl;
		cout << "CertFile  : " << mycert.GetCertFilename() << endl;
		cout << "Issuer    : " << mycert.GetIssuerSN() << endl;
		cout << "ExpiryTime: " << mycert.ExpiryTime() << endl;
		cout << "Valid For : " << mycert.ValidFor() << endl;
		cout << endl;

		Certificate issuer = mycert.GetIssuerCert(); 

		cout << "My issuer's certificate:" << endl;
		cout << "Subject   : " << issuer.GetSN() << endl;
		cout << "CertFile  : " << issuer.GetCertFilename() << endl;
		cout << "Issuer    : " << issuer.GetIssuerSN() << endl;
		cout << "ExpiryTime: " << issuer.ExpiryTime() << endl;
		cout << "Valid For : " << issuer.ValidFor() << endl;
	
		if (issuer.IsSelfSigned())
			cout << "The issuer's certificate is self-signed" << endl;
		cout << endl;
	
		list<Certificate> calist = GetCAList( );
		list<Certificate>::iterator it;
		if (calist.size()>0) {
			cout << "List of CA certificates installed:" << endl;
			for (it = calist.begin(); it != calist.end(); it++)
				cout << it->GetSN() << endl;
		}
    }
	catch (CertificateError e) {
		std::cerr << "Caught exception: " << e.what() << std::endl;
	}
}
