#include "../../auth/object_access.h"

struct soap;
enum SRMv2__TPermissionMode;
class SRMv2__TUserID;
class SRMv2__TOwnerPermission;
class ArrayOfTUserPermission;
class ArrayOfTGroupPermission;
class SRMv2__TOtherPermission;

class ObjectAccessSRMv2: public ObjectAccess {
 public:
  ObjectAccessSRMv2(void);
  ObjectAccessSRMv2(const ObjectAccess& o);
  virtual ~ObjectAccessSRMv2(void);
  SRMv2__TPermissionMode get(struct soap* sp,SRMv2__TUserID* user);
  ArrayOfTUserPermission* get(struct soap* sp);
  void modify_add(SRMv2__TUserID* user,SRMv2__TPermissionMode mode);
  void modify_remove(SRMv2__TUserID* user,SRMv2__TPermissionMode mode);
  void modify_add(SRMv2__TUserID* owner,
                  SRMv2__TOwnerPermission* ownerPermission,
                  ArrayOfTUserPermission* userPermission,
                  ArrayOfTGroupPermission* groupPermission,
                  SRMv2__TOtherPermission* otherPermission);
  void modify_remove(SRMv2__TUserID* owner,
                  SRMv2__TOwnerPermission* ownerPermission,
                  ArrayOfTUserPermission* userPermission,
                  ArrayOfTGroupPermission* groupPermission,
                  SRMv2__TOtherPermission* otherPermission);
  void modify_set(SRMv2__TUserID* owner,
                  SRMv2__TOwnerPermission* ownerPermission,
                  ArrayOfTUserPermission* userPermission,
                  ArrayOfTGroupPermission* groupPermission,
                  SRMv2__TOtherPermission* otherPermission);
  void clear(void);
};

